diff --git a/dev-python/coreapi/Manifest b/dev-python/coreapi/Manifest
new file mode 100644
index 000000000..bf4701165
--- /dev/null
+++ b/dev-python/coreapi/Manifest
@@ -0,0 +1 @@
+DIST coreapi-2.3.3.tar.gz 18788 BLAKE2B f7837d6a0430e6617a2589aa84a209b3c544a913773bc4388c3bdef7348c83577e1b216e83c14736b15174ede840ae297b050eba551b4fe22d784e4d51677956 SHA512 5a66cf9613a9e11046577684b837f48e17db2285d14a51a77aa47eb945eef72a9ee0525b7b1b1c57fddec102c144ce56430ed5a95717e77d906d0b617dce708d
diff --git a/dev-python/coreapi/coreapi-2.3.3.ebuild b/dev-python/coreapi/coreapi-2.3.3.ebuild
new file mode 100644
index 000000000..f8750629e
--- /dev/null
+++ b/dev-python/coreapi/coreapi-2.3.3.ebuild
@@ -0,0 +1,35 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+PYTHON_COMPAT=( python3_6 )
+
+inherit distutils-r1
+
+DESCRIPTION="Python client library for Core API"
+HOMEPAGE="https://github.com/core-api/python-client"
+SRC_URI="mirror://pypi/${PN:0:1}/${PN}/${P}.tar.gz"
+
+LICENSE="BSD"
+SLOT="0"
+KEYWORDS="~amd64 ~x86"
+IUSE=""
+
+RDEPEND="dev-python/coreschema[${PYTHON_USEDEP}]
+ dev-python/itypes[${PYTHON_USEDEP}]
+ dev-python/requests[${PYTHON_USEDEP}]
+ dev-python/uritemplate[${PYTHON_USEDEP}]
+"
+DEPEND="${RDEPEND}
+ dev-python/setuptools[${PYTHON_USEDEP}]
+ "
+# test? ( dev-python/mock[${PYTHON_USEDEP}]
+# )"
+
+#python_test() {
+# # Skip tests which require network access
+# py.test -k "not (test_access_token_post or test_access_token_get \
+# or test_two_legged_post or test_two_legged_get)" || die \
+# "tests failed with ${EPYTHON}"
+#}
diff --git a/dev-python/coreapi/metadata.xml b/dev-python/coreapi/metadata.xml
new file mode 100644
index 000000000..42c5f09b7
--- /dev/null
+++ b/dev-python/coreapi/metadata.xml
@@ -0,0 +1,8 @@
+
+
+
+
+ zerochaos@gentoo.org
+ Rick Farina (Zero_Chaos)
+
+
diff --git a/dev-python/django-guardian/Manifest b/dev-python/django-guardian/Manifest
new file mode 100644
index 000000000..24cb0e3a7
--- /dev/null
+++ b/dev-python/django-guardian/Manifest
@@ -0,0 +1 @@
+DIST django-guardian-2.3.0.tar.gz 159296 BLAKE2B 063e910454d62f69d93965b8e7b6c57734ca7f9191afbf99bacbe5488f3ab7e5924cb97131a049d462d7499c087d8d21f9c05c9be020bfb203930cad8c949155 SHA512 84f9825fae21e89fa62209bdb9dcd3078d280a2f6eca5cd3cde470bd416e6a788317dcf127615052b4b840b80a6b770fa5a3348ff9ea23d5c6a5518aa01fbb7d
diff --git a/dev-python/django-guardian/django-guardian-2.3.0.ebuild b/dev-python/django-guardian/django-guardian-2.3.0.ebuild
new file mode 100644
index 000000000..170ef65cf
--- /dev/null
+++ b/dev-python/django-guardian/django-guardian-2.3.0.ebuild
@@ -0,0 +1,20 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+PYTHON_COMPAT=( python3_{6,7,8} )
+
+inherit distutils-r1
+
+DESCRIPTION="Implementation of per object permissions for Django 1.2+"
+HOMEPAGE="https://github.com/django-guardian/django-guardian"
+SRC_URI="mirror://pypi/${PN:0:1}/${PN}/${P}.tar.gz"
+
+LICENSE="MIT"
+SLOT="0"
+KEYWORDS="~amd64 ~x86"
+
+CDEPEND=">=dev-python/django-2.2[${PYTHON_USEDEP}]"
+RDEPEND="${CDEPEND}"
+DEPEND="dev-python/setuptools[${PYTHON_USEDEP}]"
diff --git a/dev-python/django-guardian/metadata.xml b/dev-python/django-guardian/metadata.xml
new file mode 100644
index 000000000..db0f199f2
--- /dev/null
+++ b/dev-python/django-guardian/metadata.xml
@@ -0,0 +1,12 @@
+
+
+
+
+ johann@j-schmitz.net
+ Johann Schmitz (ercpe)
+
+
+ lukaszb/django-guardian
+ django-guardian
+
+
diff --git a/dev-python/django-oauth-toolkit/Manifest b/dev-python/django-oauth-toolkit/Manifest
new file mode 100644
index 000000000..82e4b35d7
--- /dev/null
+++ b/dev-python/django-oauth-toolkit/Manifest
@@ -0,0 +1,2 @@
+DIST django-oauth-toolkit-1.1.3.tar.gz 83783 BLAKE2B 0ab8d0c0168eec5e9a5a2b32c73775de5c806ac4d614622e268ce31b5d2e8e9d3c3f43d444da3ae9b6f0da907ea731859f19adeb0e39fa90305839182ec1fada SHA512 dae7e5f15f9820f513371684a33588c389f709c2a2a4581ba771a3c25b7125e27037869140e0071ca5695e4b630462267e28a5e99b644d64dd5059e182478e34
+DIST django-oauth-toolkit-1.2.0.tar.gz 84919 BLAKE2B e3029998219c55fc0f447046e3b4e36de3c1379dc49042981a16e1a061e62bbbb643fc2609800b0c177845b9446284fe311282a014bb3aa19bbfd5ab271c6131 SHA512 844acdd76a9dac1db6d647f09a9402370f27ad21b1118f5d78c005b9037830c1718ea825621e994ac5f4219d3938a4b824c37ffeaa15468f07a1ec0768ad4358
diff --git a/dev-python/django-oauth-toolkit/django-oauth-toolkit-1.1.3.ebuild b/dev-python/django-oauth-toolkit/django-oauth-toolkit-1.1.3.ebuild
new file mode 100644
index 000000000..c244bdf66
--- /dev/null
+++ b/dev-python/django-oauth-toolkit/django-oauth-toolkit-1.1.3.ebuild
@@ -0,0 +1,29 @@
+# Copyright 1999-2018 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=6
+
+PYTHON_COMPAT=( python3_{5,6,7} )
+
+inherit distutils-r1
+
+DESCRIPTION="OAuth2 goodies for the Djangonauts"
+HOMEPAGE="https://github.com/evonove/django-oauth-toolkit"
+#SRC_URI="mirror://pypi/${PN:0:1}/${PN}/${P}.tar.gz"
+SRC_URI="https://github.com/evonove/django-oauth-toolkit/archive/${PV}.tar.gz -> ${P}.tar.gz"
+KEYWORDS="~amd64 ~x86"
+IUSE=""
+
+LICENSE="BSD"
+SLOT="0"
+
+RDEPEND=">=dev-python/django-2.0[${PYTHON_USEDEP}]
+ >=dev-python/oauthlib-2.0.3[${PYTHON_USEDEP}]
+ >=dev-python/requests-2.13.0[${PYTHON_USEDEP}]"
+
+DEPEND="${RDEPEND}
+ dev-python/setuptools[${PYTHON_USEDEP}]
+"
+# test? ( ${RDEPEND}
+# >=dev-python/mockldap-0.2[${PYTHON_USEDEP}] )
+# doc? ( dev-python/sphinx[${PYTHON_USEDEP}] )"
diff --git a/dev-python/django-oauth-toolkit/django-oauth-toolkit-1.2.0.ebuild b/dev-python/django-oauth-toolkit/django-oauth-toolkit-1.2.0.ebuild
new file mode 100644
index 000000000..c244bdf66
--- /dev/null
+++ b/dev-python/django-oauth-toolkit/django-oauth-toolkit-1.2.0.ebuild
@@ -0,0 +1,29 @@
+# Copyright 1999-2018 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=6
+
+PYTHON_COMPAT=( python3_{5,6,7} )
+
+inherit distutils-r1
+
+DESCRIPTION="OAuth2 goodies for the Djangonauts"
+HOMEPAGE="https://github.com/evonove/django-oauth-toolkit"
+#SRC_URI="mirror://pypi/${PN:0:1}/${PN}/${P}.tar.gz"
+SRC_URI="https://github.com/evonove/django-oauth-toolkit/archive/${PV}.tar.gz -> ${P}.tar.gz"
+KEYWORDS="~amd64 ~x86"
+IUSE=""
+
+LICENSE="BSD"
+SLOT="0"
+
+RDEPEND=">=dev-python/django-2.0[${PYTHON_USEDEP}]
+ >=dev-python/oauthlib-2.0.3[${PYTHON_USEDEP}]
+ >=dev-python/requests-2.13.0[${PYTHON_USEDEP}]"
+
+DEPEND="${RDEPEND}
+ dev-python/setuptools[${PYTHON_USEDEP}]
+"
+# test? ( ${RDEPEND}
+# >=dev-python/mockldap-0.2[${PYTHON_USEDEP}] )
+# doc? ( dev-python/sphinx[${PYTHON_USEDEP}] )"
diff --git a/dev-python/python-oauth2/Manifest b/dev-python/python-oauth2/Manifest
new file mode 100644
index 000000000..f82ee75e9
--- /dev/null
+++ b/dev-python/python-oauth2/Manifest
@@ -0,0 +1,2 @@
+DIST python-oauth2-1.1.0.tar.gz 42017 BLAKE2B c0a3896f17975f55acb09b625c8ff1a4d69830156db1e7e505cc69621893554b06fad9bdf7e9e7d58558765b895b59524b9a3950c66fd642349a5679d9ee996b SHA512 51f1697d292c8fd5087886ca8cfde810a19ad54e39894e3687afedd3b69aa988da657c283a9496e03ffc2b40bb206e1e26bc7bab704ea1fe8a80e300f17e8700
+DIST python-oauth2-1.1.1.tar.gz 45363 BLAKE2B 26d502ab0f577d1ec50462bec50ce43ae94f7fd54ccc9145c731b2c1c2795f84eb939bdaea6fea43b8866076f065700a04f329c84c52114e3455507da0058d10 SHA512 5dad5ebf38298379fb430426f57f705bcfe38137c418d7b5afa837ab2473e699e0bf63cbc2078c28ca87fcdb10303f5a94cc4028739217c352eecb280a8e7847
diff --git a/dev-python/python-oauth2/python-oauth2-1.1.0-r1.ebuild b/dev-python/python-oauth2/python-oauth2-1.1.0-r1.ebuild
new file mode 100644
index 000000000..fe9652b18
--- /dev/null
+++ b/dev-python/python-oauth2/python-oauth2-1.1.0-r1.ebuild
@@ -0,0 +1,38 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+PYTHON_COMPAT=( python3_{6,7} )
+
+inherit distutils-r1
+
+DESCRIPTION="OAuth 2.0 provider for python"
+HOMEPAGE="https://pypi.python.org/pypi/python-oauth2"
+SRC_URI="mirror://pypi/${PN:0:1}/${PN}/${P}.tar.gz"
+
+LICENSE="MIT"
+SLOT="0"
+KEYWORDS="~amd64 ~x86"
+IUSE=""
+
+RDEPEND="dev-python/nose[${PYTHON_USEDEP}]
+ dev-python/pymongo[${PYTHON_USEDEP}]
+ dev-python/python-memcached[${PYTHON_USEDEP}]
+ dev-python/redis-py[${PYTHON_USEDEP}]
+ !dev-python/tornado
+ www-servers/tornado[${PYTHON_USEDEP}]
+ dev-python/mysql-connector-python[${PYTHON_USEDEP}]"
+DEPEND="${RDEPEND}
+ !!dev-python/oauth2
+ dev-python/setuptools[${PYTHON_USEDEP}]
+ "
+# test? ( dev-python/mock[${PYTHON_USEDEP}]
+# )"
+
+#python_test() {
+# # Skip tests which require network access
+# py.test -k "not (test_access_token_post or test_access_token_get \
+# or test_two_legged_post or test_two_legged_get)" || die \
+# "tests failed with ${EPYTHON}"
+#}
diff --git a/dev-python/python-oauth2/python-oauth2-1.1.1.ebuild b/dev-python/python-oauth2/python-oauth2-1.1.1.ebuild
new file mode 100644
index 000000000..fe9652b18
--- /dev/null
+++ b/dev-python/python-oauth2/python-oauth2-1.1.1.ebuild
@@ -0,0 +1,38 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+PYTHON_COMPAT=( python3_{6,7} )
+
+inherit distutils-r1
+
+DESCRIPTION="OAuth 2.0 provider for python"
+HOMEPAGE="https://pypi.python.org/pypi/python-oauth2"
+SRC_URI="mirror://pypi/${PN:0:1}/${PN}/${P}.tar.gz"
+
+LICENSE="MIT"
+SLOT="0"
+KEYWORDS="~amd64 ~x86"
+IUSE=""
+
+RDEPEND="dev-python/nose[${PYTHON_USEDEP}]
+ dev-python/pymongo[${PYTHON_USEDEP}]
+ dev-python/python-memcached[${PYTHON_USEDEP}]
+ dev-python/redis-py[${PYTHON_USEDEP}]
+ !dev-python/tornado
+ www-servers/tornado[${PYTHON_USEDEP}]
+ dev-python/mysql-connector-python[${PYTHON_USEDEP}]"
+DEPEND="${RDEPEND}
+ !!dev-python/oauth2
+ dev-python/setuptools[${PYTHON_USEDEP}]
+ "
+# test? ( dev-python/mock[${PYTHON_USEDEP}]
+# )"
+
+#python_test() {
+# # Skip tests which require network access
+# py.test -k "not (test_access_token_post or test_access_token_get \
+# or test_two_legged_post or test_two_legged_get)" || die \
+# "tests failed with ${EPYTHON}"
+#}
diff --git a/profiles/pentoo/base/package.accept_keywords/dev-python b/profiles/pentoo/base/package.accept_keywords/dev-python
index 73d8734ee..9ed4d8852 100644
--- a/profiles/pentoo/base/package.accept_keywords/dev-python
+++ b/profiles/pentoo/base/package.accept_keywords/dev-python
@@ -196,6 +196,22 @@ dev-python/pyDes
dev-python/gpapi
dev-python/matlink-gpapi
+#Tiredful-API
+~dev-python/django-filter-0.15.3
+~dev-python/django-rest-framework-3.7.3
+=dev-python/django-guardian-1.5*
+~dev-python/django-oauth-plus-2.2.8
+=dev-python/python-oauth2-1.1*
+=dev-python/mysql-connector-python-2.1*
+=dev-python/django-oauth-toolkit-1.2*
+~dev-python/oauthlib-2.0.3
+~dev-python/django-1.11.2
+~dev-python/coreapi-2.3.3
+~dev-python/itypes-1.1.0
+~dev-python/coreschema-0.0.4
+
+~dev-python/pynacl-1.2.0
+
#gemata/portage
~dev-python/bz2file-0.98
@@ -373,7 +389,6 @@ dev-python/django-formtools
dev-python/django-simple-captcha
dev-python/python-cas-haiwen
dev-python/social-auth-core
-~dev-python/oauthlib-2.0.3
~dev-python/python3-openid-3.1.0
~dev-python/python3-saml-1.9.0
dev-python/django-webpack-loader
@@ -394,6 +409,7 @@ dev-python/yamllint
dev-python/parse
dev-python/fpdf
dev-python/dlib
+dev-python/pyppeteer
dev-python/spry
dev-python/requests-html
dev-python/fake-useragent
diff --git a/profiles/pentoo/base/package.accept_keywords/www-apps b/profiles/pentoo/base/package.accept_keywords/www-apps
index a6281be4f..fd41b33be 100644
--- a/profiles/pentoo/base/package.accept_keywords/www-apps
+++ b/profiles/pentoo/base/package.accept_keywords/www-apps
@@ -2,6 +2,7 @@ www-apps/arachni
www-apps/beef
www-apps/BloodHound
www-apps/seahub
+www-apps/Tiredful-API
www-apps/geckodriver
www-apps/chromedriver-bin
diff --git a/www-apps/Tiredful-API/Tiredful-API-9999.ebuild b/www-apps/Tiredful-API/Tiredful-API-9999.ebuild
new file mode 100644
index 000000000..1ef10aabe
--- /dev/null
+++ b/www-apps/Tiredful-API/Tiredful-API-9999.ebuild
@@ -0,0 +1,29 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+PYTHON_COMPAT=( python3_{6,7} )
+inherit python-single-r1 git-r3
+
+DESCRIPTION="An intentionally designed broken web application based on REST API"
+HOMEPAGE="https://github.com/payatu/Tiredful-API"
+EGIT_REPO_URI="https://github.com/payatu/Tiredful-API.git"
+
+LICENSE="GPL-3"
+SLOT="0"
+#https://github.com/payatu/Tiredful-API/issues/9
+#KEYWORDS="~amd64"
+IUSE=""
+
+RDEPEND="dev-python/django[${PYTHON_SINGLE_USEDEP}]
+ dev-python/django-oauth-toolkit[${PYTHON_SINGLE_USEDEP}]
+ dev-python/djangorestframework[${PYTHON_SINGLE_USEDEP}]
+ dev-python/oauthlib[${PYTHON_SINGLE_USEDEP}]
+ dev-python/python-oauth2[${PYTHON_SINGLE_USEDEP}]"
+# dev-python/oauth[${PYTHON_SINGLE_USEDEP}]
+
+src_install() {
+ dodir /opt/Tiredful-API
+ cp -R "${S}"/Tiredful-API "${D}"/opt/
+}